#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int fa ()
{
  sleep(1);
  return 2;
}

int fb ()
{
  sleep (1);
  return 3;
}

int fc ()
{
  sleep (2);
  return 4;
}

int fadd (int i, int j)
{
  sleep (1);
  return i + j;
}

int fmul (int i, int j)
{
  sleep (1);
  return i * j;
}

int main ()
{
    int a, b, c = 0, d, e;

#pragma omp parallel shared(a,b,c,d,e)
#pragma omp single
  {

#pragma omp task shared(a) depend (out: a)
    a = fa ();

#pragma omp task shared(b) depend (out: b)
    b = fb ();

#pragma omp task shared(c) depend (out: c)
    c = fc ();

#pragma omp task shared(d) depend (out: d) depend(in: a, b)
    d = fadd (a, b);

#pragma omp task shared(e) depend (out: e) depend(in: c, d)
    e = fmul (c, d);

  }

  printf ("result = %d\n", e);
  
  return EXIT_SUCCESS;
}
