#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main ()
{
#pragma omp parallel
  {

    #pragma omp single nowait
    #pragma omp task
    {
      printf ("Task 1 executed by Thread %d\n", omp_get_thread_num ());
      sleep (1);
      printf ("End of Task 1\n");
    }

    #pragma omp single
    #pragma omp task
    {
      printf ("Task 2 executed by Thread %d\n", omp_get_thread_num ());
      sleep (1);
      printf ("End of Task 2\n");
    }
  }
  
  return EXIT_SUCCESS;
}
